=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2008-06-18 04:08:52 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-06-18 04:29:01 +0000
@@ -100,9 +100,6 @@
                         all_same_author = False
                         break
 
-            def url(pathargs, **kw):
-                return self._branch.url(pathargs, **kw)
-
             vals = {
                 'branch': self._branch,
                 'changes': changes,

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2008-06-18 04:08:52 +0000
+++ loggerhead/controllers/revision_ui.py	2008-06-18 09:02:55 +0000
@@ -54,8 +54,8 @@
             filter_file_id = kw.get('filter_file_id', None)
             start_revid = h.fix_revid(kw.get('start_revid', None))
             query = kw.get('q', None)
-            remember = kw.get('remember', None)
-            compare_revid = kw.get('compare_revid', None)
+            remember = h.fix_revid(kw.get('remember', None))
+            compare_revid = h.fix_revid(kw.get('compare_revid', None))
 
             try:
                 revid, start_revid, revid_list = h.get_view(revid, start_revid, filter_file_id, query)

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-06-13 05:00:06 +0000
+++ loggerhead/templates/inventory.pt	2008-06-18 08:49:45 +0000
@@ -81,7 +81,7 @@
           </td>
           <td tal:attributes="class string:filename ${file/kind}">
             <a tal:condition="python:file.kind=='directory'"
-               tal:attributes="href python:url(['/files', file.change.revno], file_id=file.file_id)"
+               tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)"
                tal:content="string:${file/filename}/">
               ${file.filename}/
             </a>
@@ -90,7 +90,7 @@
               ${file.filename}@
             </span>
             <a tal:condition="python:file.kind=='file'"
-               tal:attributes="href python:url(['/annotate', file.change.revno], file_id=file.file_id);
+               tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id);
                                title string:Annotate ${file/filename}"
                tal:content="string:${file/filename}">
               ${file.filename}

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2008-06-13 05:00:06 +0000
+++ loggerhead/templates/revision.pt	2008-06-18 09:02:55 +0000
@@ -33,44 +33,44 @@
         <div class="links">
           <div>
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/files', revid])">
+            <a tal:attributes="href python:url(['/files', change.revno])">
               browse files at revision <tal:b content="change/revno" />
             </a>
           </div>
           <div>
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/changes'], start_revid=revid)">
+            <a tal:attributes="href python:url(['/changes'], start_revid=change.revno)">
               view history from revision <tal:b content="change/revno" />
             </a>
           </div>
           <div tal:condition="python:compare_revid is not None" >
             <b>&#8594;</b>
-            <a tal:attributes="href python:branch.url(['/bundle', revid, compare_revid, 'bundle.txt'])">
+            <a tal:attributes="href python:branch.url(['/bundle', change.revno, history.get_revno(compare_revid), 'bundle.txt'])">
                 download bundle from <tal:b content="python:history.get_revno(compare_revid)" /> to <tal:b content="change/revno" />
             </a>
           </div>
-          <div tal:condition="python:(remember is not None) and (compare_revid is None) and (revid != remember)" >
+          <div tal:condition="python:(remember is not None) and (compare_revid is None) and remember != revid" >
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/revision', revid], compare_revid=remember)">
+            <a tal:attributes="href python:url(['/revision', change.revno], compare_revid=history.get_revno(remember))">
               compare with revision <tal:b content="python:history.get_revno(remember)" />
             </a>
           </div>
           <div  tal:condition="python:remember != revid">
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/revision', revid], remember=revid, compare_revid=None)">
+            <a tal:attributes="href python:url(['/revision', change.revno], remember=change.revno, compare_revid=None)">
               compare with another revision
             </a>
           </div>
           <tal:we-are-comparing condition="python:compare_revid is not None">
             <div>
               <b>&#8594;</b>
-              <a tal:attributes="href python:url([ '/revision', compare_revid ], remember=revid, compare_revid=revid)">
+              <a tal:attributes="href python:url([ '/revision', history.get_revno(compare_revid) ], remember=change.revno, compare_revid=change.revno)">
                 reverse the comparison (<tal:b content="change/revno" /> to <tal:b content="python:history.get_revno(compare_revid)" />)
               </a>
             </div>
             <div>
               <b>&#8594;</b>
-              <a tal:attributes="href python:url(['/revision', revid], remember=None, compare_revid=None)">
+              <a tal:attributes="href python:url(['/revision', change.revno], remember=None, compare_revid=None)">
                 stop comparing with revision <tal:b content="python:history.get_revno(compare_revid)" />
               </a>
             </div>
@@ -212,7 +212,7 @@
                 <tr>
                   <th class="filename" colspan="4">
                     <tal:b content="structure python:collapse_button('file', u, 'table-row')" />
-                    <a tal:attributes="href  python:url(['/annotate', change.revid], file_id=item.file_id);
+                    <a tal:attributes="href  python:url(['/annotate', change.revno], file_id=item.file_id);
                                        name  string:${item/filename}-u;
                                        title string:Annotate ${item/filename}"
                        tal:content="item/filename">

